commit:     9442449150fd9f0a061dbf632df3c1adcccd6211
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Sun Dec 18 06:22:06 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sun Dec 18 06:22:21 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=94424491

net-irc/unrealircd: add 6.0.4.2

Signed-off-by: Sam James <sam <AT> gentoo.org>

 net-irc/unrealircd/Manifest                        |   2 +
 .../unrealircd-6.0.4.2-configure-clang16.patch     |  64 +++++++
 net-irc/unrealircd/unrealircd-6.0.4.2.ebuild       | 195 +++++++++++++++++++++
 3 files changed, 261 insertions(+)

diff --git a/net-irc/unrealircd/Manifest b/net-irc/unrealircd/Manifest
index 3c494d94f4b9..6b3d222fc2da 100644
--- a/net-irc/unrealircd/Manifest
+++ b/net-irc/unrealircd/Manifest
@@ -2,3 +2,5 @@ DIST unrealircd-5.2.4.tar.gz 7201203 BLAKE2B 
06afc8b5e28bbd56971b2ce21da3e000e39
 DIST unrealircd-5.2.4.tar.gz.asc 866 BLAKE2B 
9fc520e93f80a548650b016690036c4e9957e81095f75c34489eb0b83d28548a891196469199cf354207c44b22aaeecfc696995842e9b278ab10fdf5bdb8d7f6
 SHA512 
0d85a668e2cc3f3d736f3a321e282ecb1fd94d5f605e0e40e8c84a17a6486f8e0d299ec673fe7688fca3ead847f432144ff077547cc90321534406fbe084804b
 DIST unrealircd-6.0.4.1.tar.gz 8696975 BLAKE2B 
2ca38b2eed09747f419cb9c7e338e10687541c981cce6425e266a1e0597c3a3eb36882a0d1da43a9b829aa855289887d28206b7e7298cf310e84703b1d4e7d5c
 SHA512 
c2da78e785ddd7dd1567dd4cbc6bf44d8013c84334ee2ed836bb2b265bb79cf2db620570e3e626d77389ea820365dec3cd84d27f219df0a38d6d0e364e99a3cc
 DIST unrealircd-6.0.4.1.tar.gz.asc 866 BLAKE2B 
018dd63bd02261fb390e98ebafaf9d712d30984a2034f8e4ee3c4125cf67b0dba4113f84f62e2b4ef3a42e10123f61e985ed5da42a234fe5fef30184af48520b
 SHA512 
50d98bcff738307f866ff838944bf574613fb99fa8f3a7cd34272245924f70c0c56eea6376c704c56c920f6411870f259f89155b811d6bab2d34f770fcb6e0f8
+DIST unrealircd-6.0.4.2.tar.gz 8698501 BLAKE2B 
e5252dc3e4b332adbbd5a2d435d5be14a7745777dd53b8fa72b79d4cba2c1c92c0f9381b62b9c3031f48347f2ce7086d44f619cb4ec1b4f3a4cd2020f391643b
 SHA512 
2677834660f9e6123ddf5121d9a46908f6071070cc9da085884d6c6ccec9fefc5429effa2890527a1e162984f1c5cd57bcd9cd488e8713613af84fb6d507207d
+DIST unrealircd-6.0.4.2.tar.gz.asc 866 BLAKE2B 
cdfee99a09479d6099ef42e4caa05024b682f35a7d6302b1baa2ac4697b2b430856d9cbd00f0361360050ce5f2a0478dd9c6e1dbb86ec5714de24e5edcfeaeb7
 SHA512 
3bbad079c486bd072694f246306094a5cdfc7648f49a9ec40743453bec78173454667243a05870a8a19320b31843dfcd15d962d04758cf97cccd8854dbfdfea4

diff --git 
a/net-irc/unrealircd/files/unrealircd-6.0.4.2-configure-clang16.patch 
b/net-irc/unrealircd/files/unrealircd-6.0.4.2-configure-clang16.patch
new file mode 100644
index 000000000000..d884a1000b52
--- /dev/null
+++ b/net-irc/unrealircd/files/unrealircd-6.0.4.2-configure-clang16.patch
@@ -0,0 +1,64 @@
+https://github.com/unrealircd/unrealircd/pull/242
+
+From 3246e472842237ac9e655e254380c4dd8fea7abc Mon Sep 17 00:00:00 2001
+From: Sam James <s...@gentoo.org>
+Date: Sun, 18 Dec 2022 06:18:51 +0000
+Subject: [PATCH] configure.ac: fix -Wimplicit-function-declaration
+
+Clang 16 makes -Wimplicit-function-declaration error by default.
+
+Unfortunately, this can lead to misconfiguration or miscompilation of software 
as configure
+tests may then return the wrong result.
+
+We also fix -Wstrict-prototypes while here as it's easy to do and it prepares
+us for C23.
+
+Fixes the following:
+```
+configure:6250: checking if your system has IPv6 support
+configure:6275: x86_64-pc-linux-gnu-gcc -o conftest -O2 -pipe -march=native 
-fdiagnostics-color=always -frecord-gcc-switches -Wreturn-type      -ggdb3 
-Werror=implicit-function-declaration -Werror=implicit-int -fno-strict-aliasing 
-fno-common -funsigned-char -Wall -Wextra -Waggregate-return 
-Wformat-nonliteral -Wduplicated-cond -Wduplicated-branches -Wparentheses 
-Wno-pointer-sign -Wno-format-zero-length -Wno-format-truncation 
-Wno-format-overflow -Wno-unused -Wno-unused-parameter 
-Wno-unused-but-set-parameter -Wno-char-subscripts -Wno-sign-compare 
-Wno-empty-body -Wno-pragmas  -Wl,-O1 -Wl,--as-needed 
-Wl,--defsym=__gentoo_check_ldflags__=0 -Wl,-z,pack-relative-relocs conftest.c  
>&5
+conftest.c: In function 'main':
+conftest.c:30:1: error: implicit declaration of function 'exit' 
[-Werror=implicit-function-declaration]
+   30 | exit(0); /* We only check if the code compiles, that's enough. We can 
deal with missing runtime IPv6 */
+      | ^~~~
+conftest.c:28:1: note: include '<stdlib.h>' or provide a declaration of 'exit'
+   27 | #include <sys/socket.h>
+  +++ |+#include <stdlib.h>
+   28 | int main() {
+conftest.c:30:1: warning: incompatible implicit declaration of built-in 
function 'exit' [-Wbuiltin-declaration-mismatch]
+   30 | exit(0); /* We only check if the code compiles, that's enough. We can 
deal with missing runtime IPv6 */
+      | ^~~~
+conftest.c:30:1: note: include '<stdlib.h>' or provide a declaration of 'exit'
+cc1: some warnings being treated as errors
+configure:6275: $? = 1
+```
+
+For more information, see LWN.net [0] or LLVM's Discourse [1], the Gentoo wiki 
[2],
+or the (new) c-std-porting mailing list [3].
+
+[0] https://lwn.net/Articles/913505/
+[1] 
https://discourse.llvm.org/t/configure-script-breakage-with-the-new-werror-implicit-function-declaration/65213
+[2] https://wiki.gentoo.org/wiki/Modern_C_porting
+[3] hosted at lists.linux.dev.
+--- a/configure.ac
++++ b/configure.ac
+@@ -326,7 +326,7 @@ fi
+ ])
+ AC_CACHE_CHECK(if your system prepends an underscore on 
symbols,ac_cv_underscore,[
+ cat >uscore.c << __EOF__
+-int main() {
++int main(void) {
+       return 0;
+ }
+ __EOF__
+@@ -354,7 +354,8 @@ AC_CACHE_CHECK([if your system has IPv6 support], 
[ac_cv_ip6], [
+ AC_TRY_RUN([
+ #include <sys/types.h>
+ #include <sys/socket.h>
+-int main() {
++#include <stdlib.h>
++int main(void) {
+ int s = socket(AF_INET6, SOCK_STREAM, 0);
+ exit(0); /* We only check if the code compiles, that's enough. We can deal 
with missing runtime IPv6 */
+ }
+

diff --git a/net-irc/unrealircd/unrealircd-6.0.4.2.ebuild 
b/net-irc/unrealircd/unrealircd-6.0.4.2.ebuild
new file mode 100644
index 000000000000..17d16a6be9ce
--- /dev/null
+++ b/net-irc/unrealircd/unrealircd-6.0.4.2.ebuild
@@ -0,0 +1,195 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+SSL_CERT_MANDATORY=1
+VERIFY_SIG_OPENPGP_KEY_PATH="${BROOT}"/usr/share/openpgp-keys/unrealircd.asc
+inherit autotools ssl-cert systemd tmpfiles verify-sig
+
+DESCRIPTION="An advanced Internet Relay Chat daemon"
+HOMEPAGE="https://www.unrealircd.org/";
+SRC_URI="https://www.unrealircd.org/downloads/${P}.tar.gz";
+SRC_URI+=" verify-sig? ( https://www.unrealircd.org/downloads/${P}.tar.gz.asc 
)"
+
+LICENSE="GPL-2+"
+SLOT="0"
+KEYWORDS="~amd64 ~arm ~arm64 ~ppc ~ppc64 ~riscv ~x86 ~amd64-linux"
+IUSE="class-nofakelag curl geoip +operoverride operoverride-verify"
+
+RDEPEND="
+       acct-group/unrealircd
+       acct-user/unrealircd
+       >=app-crypt/argon2-20171227-r1:=
+       dev-libs/libpcre2
+       dev-libs/libsodium:=
+       dev-libs/openssl:=
+       dev-libs/jansson:=
+       >=net-dns/c-ares-1.7:=
+       virtual/libcrypt:=
+       curl? ( net-misc/curl[adns] )
+       geoip? ( dev-libs/libmaxminddb )
+"
+DEPEND="${RDEPEND}"
+BDEPEND="
+       virtual/pkgconfig
+       verify-sig? ( sec-keys/openpgp-keys-unrealircd )
+"
+
+DOCS=( 
doc/{Authors,Donation,RELEASE-NOTES.md,tao.of.irc,technical/,translations.txt} )
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-6.0.4.2-configure-clang16.patch
+)
+
+src_prepare() {
+       # QA check against bundled pkgs
+       rm -r extras || die
+
+       # building third-party modules (which we don't do) cause a sandbox 
violation
+       # bug 704444
+       echo "" > src/buildmod || die
+
+       sed -e 's/$(MODULEFLAGS)/$(LDFLAGS) &/' -i src/modules/{,*/}Makefile.in 
|| die
+
+       if use class-nofakelag; then
+               sed -i -e 's:^//#undef\( FAKELAG_CONFIGURABLE\):#define\1:' 
include/config.h || die
+       fi
+
+       # File is missing from the 5.0.9.1 tarball
+       sed -i -e '/unrealircd-upgrade-script/d' configure.ac || die
+
+       default
+       eautoreconf
+}
+
+src_configure() {
+       # Default value for privatelibdir adds a build path to -Wl,-rpath.
+       econf \
+               --with-bindir="${EPREFIX}"/usr/bin \
+               --with-cachedir="${EPREFIX}"/var/lib/${PN} \
+               --with-confdir="${EPREFIX}"/etc/${PN} \
+               --with-datadir="${EPREFIX}"/var/lib/${PN} \
+               --with-docdir="${EPREFIX}"/usr/share/doc/${PF} \
+               --with-logdir="${EPREFIX}"/var/log/${PN} \
+               --with-modulesdir="${EPREFIX}/usr/$(get_libdir)"/${PN}/modules \
+               --without-privatelibdir \
+               --with-pidfile="${EPREFIX}"/run/${PN}/ircd.pid \
+               --with-tmpdir="${EPREFIX}"/var/lib/${PN}/tmp \
+               --with-maxconnections=1024 \
+               --with-nick-history=2000 \
+               --with-permissions=0640 \
+               --with-system-argon2 \
+               --with-system-cares \
+               --with-system-pcre2 \
+               --with-system-sodium \
+               --with-system-jansson \
+               --enable-dynamic-linking \
+               --with-controlfile="${EPREFIX}"/run/${PN}/unrealircd.ctl \
+               --enable-ssl="${EPREFIX}"/usr \
+               $(use_enable curl libcurl "${EPREFIX}"/usr) \
+               $(use_with !operoverride no-operoverride) \
+               $(use_with operoverride-verify) \
+               $(use_enable geoip libmaxminddb)
+}
+
+src_install() {
+       keepdir /var/log/${PN}
+       keepdir /var/lib/${PN}/tmp
+
+       newbin src/ircd ${PN}
+       dobin src/unrealircdctl
+
+       newtmpfiles "${FILESDIR}"/unrealircd.tmpfiles unrealircd.conf
+
+       (
+               cd src/modules || die
+               for subdir in $(find . -type d -print); do
+                       if [[ -n $(shopt -s nullglob; echo ${subdir}/*.so) ]]; 
then
+                               exeinto 
/usr/$(get_libdir)/${PN}/modules/"${subdir}"
+                               doexe "${subdir}"/*.so
+                       fi
+               done
+       )
+
+       insinto /etc/${PN}
+       # Purposefully omitting the examples/ and ssl/ subdirectories. ssl
+       # is redundant with app-misc/ca-certificates and examples will all
+       # be in docs anyway.
+       doins -r doc/conf/{aliases,help}
+       doins doc/conf/*.conf
+       newins doc/conf/examples/example.conf ${PN}.conf
+       keepdir /etc/${PN}/tls
+
+       einstalldocs
+
+       newinitd "${FILESDIR}"/${PN}.initd-r3 ${PN}
+       newconfd "${FILESDIR}"/${PN}.confd-r4 ${PN}
+
+       # config should be read-only
+       fperms -R 0640 /etc/${PN}
+       fperms 0750 /etc/${PN}{,/aliases,/help}
+       fperms 0750 /etc/${PN}/tls
+       # state is editable but not owned by unrealircd directly
+       fperms 0770 /var/log/${PN}
+       fperms 0770 /var/lib/${PN}{,/tmp}
+       fowners -R root:unrealircd /{etc,var/{lib,log}}/${PN}
+
+       # By default looks in /etc/unrealircd/ssl/curl-ca-bundle.crt. Fix
+       # that to look for ca-certificates-provided file instead. %s is
+       # CONFDIR. #618066
+       dosym ../../ssl/certs/ca-certificates.crt 
/etc/${PN}/tls/curl-ca-bundle.crt
+
+       systemd_dounit "${FILESDIR}"/${PN}.service
+}
+
+pkg_postinst() {
+       tmpfiles_process unrealircd.conf
+
+       # Move docert call from src_install() to install_cert in pkg_postinst 
for
+       # bug #201682
+       if [[ ! -f "${EROOT}"/etc/${PN}/tls/server.cert.key ]]; then
+               if [[ -f "${EROOT}"/etc/${PN}/ssl/server.cert.key ]]; then
+                       ewarn "The location ${PN} looks for SSL certificates 
has changed"
+                       ewarn "from ${EROOT}/etc/${PN}/ssl to 
${EROOT}/etc/${PN}/tls."
+                       ewarn "Please move your existing certificates."
+               else
+                       (
+                               umask 0037
+                               install_cert /etc/${PN}/tls/server.cert
+                               chown unrealircd 
"${EROOT}"/etc/${PN}/tls/server.cert.*
+                               ln -snf server.cert.key 
"${EROOT}"/etc/${PN}/tls/server.key.pem
+                       )
+               fi
+       fi
+
+       local unrealircd_conf="${EROOT}"/etc/${PN}/${PN}.conf
+       # Fix up the default cloak keys.
+       if grep -qe '"and another one";$' "${unrealircd_conf}" && grep -qe 
'"Oozahho1raezoh0iMee4ohvegaifahv5xaepeitaich9tahdiquaid0geecipahdauVaij3zieph4ahi";$'
 "${unrealircd_conf}"; then
+               ebegin "Generating cloak-keys"
+               local keys=(
+                       $(su ${PN} -s "${EPREFIX}"/bin/sh -c "${PN} -k 2>&1 | 
tail -n 6 | head -n 3")
+               )
+               [[ -n ${keys[0]} || -n ${keys[1]} || -n ${keys[2]} ]]
+               eend $?
+
+               ebegin "Substituting cloak-keys into ${unrealircd_conf}"
+               sed -i \
+                       -e '/cloak-keys/ {
+n
+s/"Oozahho1raezoh0iMee4ohvegaifahv5xaepeitaich9tahdiquaid0geecipahdauVaij3zieph4ahi";/'${keys[0]}'/
+n
+s/"and another one";/'${keys[1]}'/
+n
+s/"and another one";/'${keys[2]}'/
+}' \
+                       "${unrealircd_conf}"
+               eend $?
+       fi
+
+       elog "UnrealIRCd will not run until you've set up 
${EROOT}/etc/unrealircd/unrealircd.conf"
+       elog
+       elog "You can also configure ${PN} start at boot with rc-update(1)."
+       elog "It is recommended to run unrealircd as an unprivileged user."
+       elog "The provided init.d script does this for you."
+}

Reply via email to